<center><a href="ex16f.F">Actual source code: ex16f.F</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:29:53+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80"><a name="line1">  1: </a>!
<a name="line2">  2: </a>      program main
<a name="line3">  3: </a>       implicit none

<a name="line5"> 5: </a> #include <A href="../../../../../include/finclude/petsc.h.html">include/finclude/petsc.h</A>
<a name="line6"> 6: </a> #include <A href="../../../../../include/finclude/petscvec.h.html">include/finclude/petscvec.h</A>
<a name="line7"> 7: </a> #include <A href="../../../../../include/finclude/petscmat.h.html">include/finclude/petscmat.h</A>
<a name="line8"> 8: </a> #include <A href="../../../../../include/finclude/petscpc.h.html">include/finclude/petscpc.h</A>
<a name="line9"> 9: </a> #include <A href="../../../../../include/finclude/petscksp.h.html">include/finclude/petscksp.h</A>
<a name="line10"> 10: </a> #include <A href="../../../../../include/finclude/petscviewer.h.html">include/finclude/petscviewer.h</A>
<a name="line11"> 11: </a> #include <A href="../../../../../include/finclude/petscis.h.html">include/finclude/petscis.h</A>
<a name="line12"> 12: </a>!
<a name="line13"> 13: </a>!  This example is a modified Fortran version of ex6.c.  It tests the use of
<a name="line14"> 14: </a>!  options prefixes in PETSc. Two linear problems are solved in this program.
<a name="line15"> 15: </a>!  The first problem is read from a file. The second problem is constructed
<a name="line16"> 16: </a>!  from the first, by eliminating some of the entries of the linear matrix 'A'.

<a name="line18"> 18: </a>!  Each solve is distinguished by a unique prefix - 'a' <font color="#4169E1">for</font> the first, 'b'
<a name="line19"> 19: </a>!  <font color="#4169E1">for</font> the second.  With the prefix the user can distinguish between the various
<a name="line20"> 20: </a>!  options (command line, from .petscrc file, etc.) <font color="#4169E1">for</font> each of the solvers.
<a name="line21"> 21: </a>!  Input arguments are:
<a name="line22"> 22: </a>!     -f &lt;input_file&gt; : file to load.  For a 5X5 example of the 5-pt. stencil
<a name="line23"> 23: </a>!                       use the file petsc/src/mat/examples/mat.ex.binary

<a name="line25"> 25: </a>      <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  ierr
<a name="line26"> 26: </a>      <A href="../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> its,ione,ifive,izero
<a name="line27"> 27: </a>      <A href="../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> flg
<a name="line28"> 28: </a>      <A href="../../../../../docs/manualpages/Sys/PetscScalar.html#PetscScalar">PetscScalar</A>      norm,none,five
<a name="line29"> 29: </a>      <A href="../../../../../docs/manualpages/Vec/Vec.html#Vec">Vec</A>              x,b,u
<a name="line30"> 30: </a>      <A href="../../../../../docs/manualpages/Mat/Mat.html#Mat">Mat</A>              A
<a name="line31"> 31: </a>      <A href="../../../../../docs/manualpages/KSP/KSP.html#KSP">KSP</A>             ksp1,ksp2
<a name="line32"> 32: </a>      character*(128)  f
<a name="line33"> 33: </a>      <A href="../../../../../docs/manualpages/Viewer/PetscViewer.html#PetscViewer">PetscViewer</A>      fd
<a name="line34"> 34: </a>      <A href="../../../../../docs/manualpages/IS/IS.html#IS">IS</A>               isrow
<a name="line35"> 35: </a>      none  = -1.0
<a name="line36"> 36: </a>      five  = 5.0
<a name="line37"> 37: </a>      ifive = 5
<a name="line38"> 38: </a>      ione  = 1
<a name="line39"> 39: </a>      izero = 0

<a name="line41"> 41: </a>      call <A href="../../../../../docs/manualpages/Sys/PetscInitialize.html#PetscInitialize">PetscInitialize</A>(PETSC_NULL_CHARACTER,ierr)
<a name="line42"> 42: </a>
<a name="line43"> 43: </a>! Read in matrix and RHS
<a name="line44"> 44: </a>      call <A href="../../../../../docs/manualpages/Sys/PetscOptionsGetString.html#PetscOptionsGetString">PetscOptionsGetString</A>(PETSC_NULL_CHARACTER,'-f',f,flg,ierr)
<a name="line45"> 45: </a>      call <A href="../../../../../docs/manualpages/Viewer/PetscViewerBinaryOpen.html#PetscViewerBinaryOpen">PetscViewerBinaryOpen</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,f,FILE_MODE_READ,            &amp;
<a name="line46"> 46: </a>     &amp;     fd,ierr)
<a name="line47"> 47: </a>      <font color="#4169E1">if</font> (ierr .ne. 0) then
<a name="line48"> 48: </a>        print*, 'Unable to open file ',f
<a name="line49"> 49: </a>        <A href="../../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(1,' ',ierr)
<a name="line50"> 50: </a>      endif

<a name="line52"> 52: </a>      call <A href="../../../../../docs/manualpages/Mat/MatLoad.html#MatLoad">MatLoad</A>(fd,<A href="../../../../../docs/manualpages/Mat/MATSEQAIJ.html#MATSEQAIJ">MATSEQAIJ</A>,A,ierr)
<a name="line53"> 53: </a>      <font color="#4169E1">if</font> (ierr .ne. 0) then
<a name="line54"> 54: </a>        print*, 'Unable to load matrix '
<a name="line55"> 55: </a>        <A href="../../../../../docs/manualpages/Sys/SETERRQ.html#SETERRQ">SETERRQ</A>(1,' ',ierr)
<a name="line56"> 56: </a>      endif

<a name="line58"> 58: </a>      call <A href="../../../../../docs/manualpages/Vec/VecLoad.html#VecLoad">VecLoad</A>(fd,PETSC_NULL_CHARACTER,b,ierr)
<a name="line59"> 59: </a>      call <A href="../../../../../docs/manualpages/Viewer/PetscViewerDestroy.html#PetscViewerDestroy">PetscViewerDestroy</A>(fd,ierr)

<a name="line61"> 61: </a>! Set up solution
<a name="line62"> 62: </a>      call <A href="../../../../../docs/manualpages/Vec/VecDuplicate.html#VecDuplicate">VecDuplicate</A>(b,x,ierr)
<a name="line63"> 63: </a>      call <A href="../../../../../docs/manualpages/Vec/VecDuplicate.html#VecDuplicate">VecDuplicate</A>(b,u,ierr)

<a name="line65"> 65: </a>! Solve system-1
<a name="line66"> 66: </a>      call <A href="../../../../../docs/manualpages/KSP/KSPCreate.html#KSPCreate">KSPCreate</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,ksp1,ierr)
<a name="line67"> 67: </a>      call <A href="../../../../../docs/manualpages/KSP/KSPSetOptionsPrefix.html#KSPSetOptionsPrefix">KSPSetOptionsPrefix</A>(ksp1,'a',ierr)
<a name="line68"> 68: </a>      call <A href="../../../../../docs/manualpages/KSP/KSPAppendOptionsPrefix.html#KSPAppendOptionsPrefix">KSPAppendOptionsPrefix</A>(ksp1,'_',ierr)
<a name="line69"> 69: </a>      call <A href="../../../../../docs/manualpages/KSP/KSPSetOperators.html#KSPSetOperators">KSPSetOperators</A>(ksp1,A,A,DIFFERENT_NONZERO_PATTERN,ierr)
<a name="line70"> 70: </a>      call <A href="../../../../../docs/manualpages/KSP/KSPSetFromOptions.html#KSPSetFromOptions">KSPSetFromOptions</A>(ksp1,ierr)
<a name="line71"> 71: </a>      call <A href="../../../../../docs/manualpages/KSP/KSPSolve.html#KSPSolve">KSPSolve</A>(ksp1,b,x,ierr)

<a name="line73"> 73: </a>! Show result
<a name="line74"> 74: </a>      call <A href="../../../../../docs/manualpages/Mat/MatMult.html#MatMult">MatMult</A>(A,x,u,ierr)
<a name="line75"> 75: </a>      call <A href="../../../../../docs/manualpages/Vec/VecAXPY.html#VecAXPY">VecAXPY</A>(u,none,b,ierr)
<a name="line76"> 76: </a>      call <A href="../../../../../docs/manualpages/Vec/VecNorm.html#VecNorm">VecNorm</A>(u,<A href="../../../../../docs/manualpages/Vec/NORM_2.html#NORM_2">NORM_2</A>,norm,ierr)
<a name="line77"> 77: </a>      call <A href="../../../../../docs/manualpages/KSP/KSPGetIterationNumber.html#KSPGetIterationNumber">KSPGetIterationNumber</A>(ksp1,its,ierr)


<a name="line80"> 80: </a>      write(6,100) norm,its
<a name="line81"> 81: </a>  100 format('Residual norm ',e10.4,' iterations ',i5)

<a name="line83"> 83: </a>! Create system 2 by striping off some rows of the matrix
<a name="line84"> 84: </a>      call <A href="../../../../../docs/manualpages/IS/ISCreateStride.html#ISCreateStride">ISCreateStride</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_SELF.html#PETSC_COMM_SELF">PETSC_COMM_SELF</A>,ifive,izero,ione,isrow,ierr)
<a name="line85"> 85: </a>      call <A href="../../../../../docs/manualpages/Mat/MatZeroRowsIS.html#MatZeroRowsIS">MatZeroRowsIS</A>(A,isrow,five,ierr)

<a name="line87"> 87: </a>! Solve system-2
<a name="line88"> 88: </a>      call <A href="../../../../../docs/manualpages/KSP/KSPCreate.html#KSPCreate">KSPCreate</A>(<A href="../../../../../docs/manualpages/Sys/PETSC_COMM_WORLD.html#PETSC_COMM_WORLD">PETSC_COMM_WORLD</A>,ksp2,ierr)
<a name="line89"> 89: </a>      call <A href="../../../../../docs/manualpages/KSP/KSPSetOptionsPrefix.html#KSPSetOptionsPrefix">KSPSetOptionsPrefix</A>(ksp2,'b',ierr)
<a name="line90"> 90: </a>      call <A href="../../../../../docs/manualpages/KSP/KSPAppendOptionsPrefix.html#KSPAppendOptionsPrefix">KSPAppendOptionsPrefix</A>(ksp2,'_',ierr)
<a name="line91"> 91: </a>      call <A href="../../../../../docs/manualpages/KSP/KSPSetOperators.html#KSPSetOperators">KSPSetOperators</A>(ksp2,A,A,DIFFERENT_NONZERO_PATTERN,ierr)
<a name="line92"> 92: </a>      call <A href="../../../../../docs/manualpages/KSP/KSPSetFromOptions.html#KSPSetFromOptions">KSPSetFromOptions</A>(ksp2,ierr)
<a name="line93"> 93: </a>      call <A href="../../../../../docs/manualpages/KSP/KSPSolve.html#KSPSolve">KSPSolve</A>(ksp2,b,x,ierr)

<a name="line95"> 95: </a>! Show result
<a name="line96"> 96: </a>      call <A href="../../../../../docs/manualpages/Mat/MatMult.html#MatMult">MatMult</A>(A,x,u,ierr)
<a name="line97"> 97: </a>      call <A href="../../../../../docs/manualpages/Vec/VecAXPY.html#VecAXPY">VecAXPY</A>(u,none,b,ierr)
<a name="line98"> 98: </a>      call <A href="../../../../../docs/manualpages/Vec/VecNorm.html#VecNorm">VecNorm</A>(u,<A href="../../../../../docs/manualpages/Vec/NORM_2.html#NORM_2">NORM_2</A>,norm,ierr)
<a name="line99"> 99: </a>      call <A href="../../../../../docs/manualpages/KSP/KSPGetIterationNumber.html#KSPGetIterationNumber">KSPGetIterationNumber</A>(ksp2,its,ierr)
<a name="line100">100: </a>      write(6,100) norm,its

<a name="line102">102: </a>! Cleanup
<a name="line103">103: </a>      call <A href="../../../../../docs/manualpages/KSP/KSPDestroy.html#KSPDestroy">KSPDestroy</A>(ksp1,ierr)
<a name="line104">104: </a>      call <A href="../../../../../docs/manualpages/KSP/KSPDestroy.html#KSPDestroy">KSPDestroy</A>(ksp2,ierr)
<a name="line105">105: </a>      call <A href="../../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(b,ierr)
<a name="line106">106: </a>      call <A href="../../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(x,ierr)
<a name="line107">107: </a>      call <A href="../../../../../docs/manualpages/Vec/VecDestroy.html#VecDestroy">VecDestroy</A>(u,ierr)
<a name="line108">108: </a>      call <A href="../../../../../docs/manualpages/Mat/MatDestroy.html#MatDestroy">MatDestroy</A>(A,ierr)
<a name="line109">109: </a>      call <A href="../../../../../docs/manualpages/IS/ISDestroy.html#ISDestroy">ISDestroy</A>(isrow,ierr)

<a name="line111">111: </a>      call <A href="../../../../../docs/manualpages/Sys/PetscFinalize.html#PetscFinalize">PetscFinalize</A>(ierr)
<a name="line112">112: </a>      end

</pre>
</body>

</html>
